'   Climes.bas - Climate/Terrain Weather Data Recorder
'   Version 2.00
'   23 March 1992
'   Michael J. McLaughlin

    DECLARE SUB Introduction (cm$)

    CLEAR
    DEF FNMOO (a) = a - 96
    DIM TEMP(12, 3), precip(4, 3), hlevel(4), SEASON$(4), xw$(4)
   
    SEASON$(1) = "Winter": SEASON$(2) = "Spring": SEASON$(3) = "Summer": SEASON$(4) = "Autumn"

    OPEN "weather.cnf" FOR INPUT AS #1
    INPUT #1, campyear, datdir$, day
    CLOSE
   
    CLS :
    INPUT "Color or Mono display (C/m) "; cm$
    cm$ = UCASE$(cm$)

5   IF cm$ <> "M" THEN COLOR 14, 0, 0
    CLS
    PRINT TAB(22); "Climate & Terrain Weather Data Recorder"
    PRINT STRING$(80, CHR$(205))
    VIEW PRINT 3 TO 24
   
    IF cm$ <> "M" THEN COLOR 7, 0, 0
    INPUT "Do you need instructions (y/N) "; ans$
    IF UCASE$(ans$) = "Y" THEN CALL Introduction(cm$)

    PRINT
1   INPUT "Climate/Area name for data entry "; cli$
    IF LEN(cli$) < 1 THEN 1
    cli$ = UCASE$(LEFT$(cli$, 1)) + LCASE$(RIGHT$(cli$, LEN(cli$) - 1))
2   INPUT "Terrain for data entry "; ter$
    IF LEN(ter$) < 1 THEN 1
    ter$ = UCASE$(LEFT$(ter$, 1)) + LCASE$(RIGHT$(ter$, LEN(ter$) - 1))
    PRINT
    PRINT cli$, ter$
    PRINT
    PRINT "Default datafile name is "; UCASE$(LEFT$(cli$, 4) + LEFT$(ter$, 4)) + ".DAT"
    INPUT "Is this acceptable (Y/n) "; ans$
    IF UCASE$(ans$) = "N" THEN
        PRINT
        INPUT "New filename "; fm$
    END IF
    fm$ = UCASE$(datdir$ + LEFT$(cli$, 4) + LEFT$(ter$, 4) + ".dat")
   
    CLS 2
    IF cm$ <> "M" THEN COLOR 9, 0
    PRINT "Maximum Wind Velocity :"
    IF cm$ <> "M" THEN COLOR 7, 0
    PRINT
    PRINT "Normal maximum wind speeds are in the range of 20 to 30 mph"
    PRINT "This entry will be rounded to the nearest 5 mph."
20  PRINT : INPUT "Maximum wind velocity (mph) "; windmax
    IF windmax < 0 THEN 20
    IF (windmax MOD 5) <> 0 THEN windmax = INT(windmax / 5) * 5

    IF cm$ <> "M" THEN COLOR 9, 0
    PRINT "Temperature variation"
    IF cm$ <> "M" THEN COLOR 7, 0
    PRINT "Input values for the given temperature levels of the particular month"
    PRINT "as prompted.  This is not a case sensitive function."
    IF cm$ <> "M" THEN COLOR 9, 0
    PRINT "Temperature Levels"
    PRINT STRING$(80, CHR$(196))
    IF cm$ <> "M" THEN COLOR 1, 0
    PRINT "Level     High    Low         Level     High    Low"
    IF cm$ <> "M" THEN COLOR 7, 0
    PRINT "  A       -20     -40           O        70      55"
    PRINT "  B       -15     -30           P        75      55"
    IF cm$ <> "M" THEN
        COLOR 8, 0
        PRINT "  C        -5     -20           Q        80      60"
        COLOR 7, 0
    ELSE
        PRINT "  C        -5     -20           Q        80      60"
    END IF
    PRINT "  D         0     -10           R        80      65"
    PRINT "  E        10       0           S        85      65"
    IF cm$ <> "M" THEN
        COLOR 8, 0
        PRINT "  F        18      10           T        85      70"
        COLOR 7, 0
    ELSE
        PRINT "  F        18      10           T        85      70"
    END IF
    PRINT "  G        25      10           U        90      70"
    PRINT "  H        30      15           V        90      75"
    IF cm$ <> "M" THEN
        COLOR 8, 0
        PRINT "  I        35      15           W        95      75"
        COLOR 7, 0
    ELSE
        PRINT "  I        35      15           W        95      75"
    END IF
    PRINT "  J        40      20           X       100      80"
    PRINT "  K        50      30           Y       105      80"
    IF cm$ <> "M" THEN
        COLOR 8, 0
        PRINT "  L        60      40           Z       115      85"
        COLOR 7, 0
    ELSE
        PRINT "  L        60      40           Z       115      85"
    END IF
    PRINT "  M        65      45"
    PRINT "  N        70      50         All temps degrees F."
    PRINT
    VIEW PRINT 23 TO 25
    FOR x = 1 TO 12
        PRINT : PRINT "Month = "; x
10      INPUT "Minimum, mean and maximum temperatures "; a$, b$, c$
        a$ = LCASE$(a$): b$ = LCASE$(b$): c$ = LCASE$(c$)
        TEMP(x, 1) = FNMOO(ASC(a$))
        TEMP(x, 2) = FNMOO(ASC(b$))
        TEMP(x, 3) = FNMOO(ASC(c$))
    NEXT x
     
    VIEW PRINT 3 TO 24: CLS 2

    IF cm$ <> "M" THEN COLOR 9, 0
    PRINT : PRINT : PRINT "Precipitation variation"
    IF cm$ <> "M" THEN COLOR 7, 0
    PRINT "Input the numerical value that represents the required precipitation"
    PRINT "levels.  B is the least common form while A & C are equally common."
    IF cm$ <> "M" THEN COLOR 9, 0
    PRINT : PRINT "Precipitation Levels"
    PRINT STRING$(80, CHR$(196))
    IF cm$ <> "M" THEN COLOR 1, 0
    PRINT "  Level       Precipitation Form"
    IF cm$ <> "M" THEN COLOR 7, 0
    PRINT "    0         No precipitation"
    PRINT "    1         Trace precipitation"
    PRINT "    2         Light precipitation"
    PRINT "    3         Moderate precipitation"
    PRINT "    4         Heavy precipitation"
    PRINT "    5         Downpour"

    VIEW PRINT 18 TO 24
    FOR x = 1 TO 4
        PRINT : PRINT SEASON$(x)
30      INPUT "Precipitation levels A,B,C "; precip(x, 1), precip(x, 2), precip(x, 3)
        FOR y = 1 TO 3
            IF precip(x, y) < 0 OR precip(x, y) > 5 OR precip(x, y) <> INT(precip(x, y)) THEN 30
        NEXT y
    NEXT x
    VIEW PRINT 3 TO 24: CLS 2

    IF cm$ <> "M" THEN COLOR 9, 0
    PRINT "Extreme Weather Codes"
    IF cm$ <> "M" THEN COLOR 7, 0
    PRINT "Input the letters corresponding to the encountered extreme weather"
    PRINT "conditions of this area in the form of #### proceeding from uncommon to"
    PRINT "two common entries and returning to uncommom. (eg  ATXZ)"
    PRINT "Note : Code X for `new' climates  may require coding changes to have"
    PRINT "       Any noticable effect."
    PRINT
    IF cm$ <> "M" THEN COLOR 9, 0
    PRINT "Extreme Weather Codes"
    PRINT STRING$(80, CHR$(196))
    IF cm$ <> "M" THEN COLOR 1, 0
    PRINT "Code      Weather Form        Code        Weather Form"
    IF cm$ <> "M" THEN COLOR 7, 0
    PRINT " A        Cold Wave            S          Sandstorm/Dust Storm"
    PRINT " C        Cyclone/Hurricane    T          Tornado"
    PRINT " D        Drought              X          Extreme Precipitation"
    PRINT " G        Gale                 Z          Heat Wave"
    PRINT " M        Mist/Fog"

    VIEW PRINT 20 TO 24
    FOR x = 1 TO 4
        PRINT : PRINT SEASON$(x)
        INPUT "Extreme weather code :"; xw$(x)
        xw$(x) = UCASE$(xw$(x))
    NEXT x
  
    VIEW PRINT 3 TO 24: CLS 2

    IF cm$ <> "M" THEN COLOR 9, 0
    PRINT "Humidity Levels"
    IF cm$ <> "M" THEN COLOR 7, 0
    PRINT "Input the numerical values corresponding to prevailing humidity"
    PRINT "of each of the seasons.  (eg 1,2,2,1)"
    PRINT
    IF cm$ <> "M" THEN COLOR 9, 0
    PRINT "Humidity Levels"
    PRINT STRING$(80, CHR$(196))
    IF cm$ <> "M" THEN COLOR 1, 0
    PRINT "Level     Humidity"
    IF cm$ <> "M" THEN COLOR 7, 0
    PRINT "  1       Low ( < = 41 % )"
    PRINT "  2       Medium ( 41 - 70 % )"
    PRINT "  3       Heavy ( 71 % + )"
   
   
40  PRINT : INPUT "Humitity levels (Wn,Sp,Sm,Am) "; hlevel(1), hlevel(2), hlevel(3), hlevel(4)
    FOR x = 1 TO 4
        IF hlevel(x) <> INT(hlevel(x)) OR hlevel(x) < 1 OR hlevel(x) > 3 THEN 40
    NEXT x

    OPEN fm$ FOR OUTPUT AS #1
        WRITE #1, cli$, ter$
        WRITE #1, windmax
        FOR x = 1 TO 12
            WRITE #1, TEMP(x, 1), TEMP(x, 2), TEMP(x, 3)
        NEXT x
        FOR x = 1 TO 4
            WRITE #1, precip(x, 1), precip(x, 2), precip(x, 3)
        NEXT x
        WRITE #1, hlevel(1), hlevel(2), hlevel(3), hlevel(4)
        FOR x = 1 TO 4
            WRITE #1, xw$(x)
        NEXT x
    CLOSE
   
    VIEW PRINT
    CLS
    LOCATE 8, 20: INPUT "Another Terrain/Climate Combination (y/N)"; ans$
    IF ans$ = "Y" OR ans$ = "y" THEN 5
    END

SUB Introduction (cm$)
   
    CLS 2
    IF cm$ <> "M" THEN COLOR 6, 0
    PRINT "  This program is designed to generate data files for use with the"
    PRINT "weather generator progam, version 2.0+.  Particular data files that"
    PRINT "would be best addressed by this program would be cities or areas with"
    PRINT "weather patterns that do no fit well into the divisions of the generic"
    PRINT "climate/terrain files."
    PRINT
    PRINT "  A note on naming convention is in order though.  The terrain portion"
    PRINT "of the name should be one of those provided for in the original files,"
    PRINT "particularly if the new locale is on a seacoast."
    PRINT
    PRINT "  The filenames of these data files is composed of the first four characters"
    PRINT "of the climate name and the first four characters of the terrain name. Conflicts"
    PRINT "may occur, so be careful about overwriting data files.  An example filename"
    PRINT "would be WATESEAC.DAT for Waterdeep/Seacoast.  Provisions have been made to"
    PRINT "bypass the default filename."
    PRINT
    IF cm$ <> "M" THEN COLOR 7, 0

END SUB

