    'Weather Generator
    'Version 3.00
    '22 March 1992
    'Michael J. McLaughlin
  
    ' Declare Subfunctions
   
    DECLARE SUB Introduction ()
    DECLARE SUB CalendarReport (cal, day, year, pdays)
    DECLARE SUB Moon (day, year, pdays, ter$)

    CLEAR
   
    ON ERROR GOTO ErrorHandler
   
    RANDOMIZE (VAL(RIGHT$(TIME$, 2)) * VAL(MID$(TIME$, 4, 2)) * VAL(LEFT$(TIME$, 2)) / 2.75)
    DIM dht(27), dlt(27), WD$(3), temp(12, 3), precip(4, 3), pre$(10), tter$(7)
    DIM tcli$(5), hlevel(4), rxw$(4), xw$(4, 4), wcdata(17, 8)
   
    ' Initialize Program ******
    CALL Introduction: '          ******* Run Introduction
    GOSUB 220: '                  ******* Read Configuration File
    GOSUB 20: '                   ******* Fetch Starting Date
    GOSUB 31: '                   ******* Initialize Temp/Precip Data
    GOSUB 40: '                   ******* Fetch Daily Temperature Data
    GOSUB 50: '                   ******* Initialize Values Segment
    GOTO 60: '                    ******* Go To Main Program

31  ' Initialize Temperature/Precipitation Data ******
   
    pre$(0) = "No precipitation"
    pre$(1) = "Trace precipitation (0.125in rain/0.5in snow)"
    pre$(2) = "Light precipitation (0.5in rain/1in snow)"
    pre$(3) = "Moderate precipitation (0.75in rain/2in snow)"
    pre$(4) = "Heavy precipitation (1.5in rain/4in snow)"
    pre$(5) = "Downpour (1.5in+ rain)"
    pre$(6) = "Torrential (3in+ rain)"
    pre$(7) = "Hailstorm"
    pre$(8) = "Ice/Sleet Storm"
    pre$(9) = "Lightening Storm"
    pre$(10) = "Severe Snowstorm"
   
    DATA "Artic","Subartic","Temperate","Subtropical","Tropical"
    DATA "Desert","Forest","Hills","Mountains","Plains","Seacoast","Swamp"
    FOR x = 1 TO 5
        READ tcli$(x)
    NEXT x
    FOR x = 1 TO 7
        READ tter$(x)
    NEXT x

   
30  ' Open Climate/Terrain Data File ******
   
    CLS
    LOCATE 5, 10: INPUT "Do you have a non-standard climate/terrain file "; ans$
    IF UCASE$(ans$) <> "Y" THEN 36
    CLS
    PRINT TAB(20); "Available Data Files in this directory"
    PRINT
    FILES datdir$ + "*.dat"
    PRINT
    INPUT "Datafile name :"; fm$
    fm$ = datdir$ + fm$
    GOTO 37

36  CLS
    LOCATE 6, 30: PRINT " # ", "Climate"
    LOCATE 7, 30: PRINT STRING$(3, CHR$(205)), STRING$(7, CHR$(205))
    FOR x = 1 TO 5
        LOCATE (7 + x), 30: PRINT x, tcli$(x)
    NEXT x
    LOCATE 14, 30: PRINT "Number of Desired Climate "; : a$ = INPUT$(1)
    clinum = VAL(a$)
    IF clinum <> INT(clinum) THEN 30
    IF clinum > 5 OR clinum < 1 THEN 30
    cli$ = tcli$(clinum)

34  CLS
    LOCATE 6, 30: PRINT " # ", "Terrain"
    LOCATE 7, 30: PRINT STRING$(3, CHR$(205)), STRING$(7, CHR$(205))
    FOR x = 1 TO 7
        LOCATE (7 + x), 30: PRINT x, tter$(x)
    NEXT x
    LOCATE 16, 30: PRINT "Number of Desired Terrain "; : a$ = INPUT$(1)
    ternum = VAL(a$)
    IF ternum <> INT(ternum) THEN 34
    IF ternum > 7 OR ternum < 1 THEN 34
    ter$ = tter$(ternum)
   
35  fm$ = datdir$ + LEFT$(cli$, 4) + LEFT$(ter$, 4) + ".dat"
37  CLS
    OPEN fm$ FOR INPUT AS #1
    INPUT #1, cli$, ter$
    LOCATE 8, 20
    PRINT cli$, ter$
    LOCATE 10, 20
    INPUT "Is this the correct combination (Y/n) "; a$
    IF a$ = "n" OR a$ = "N" THEN 32 ELSE 33
32  CLOSE : GOTO 30
33  INPUT #1, maxwind
    FOR x = 1 TO 12
        FOR y = 1 TO 3
            INPUT #1, temp(x, y)
        NEXT y
    NEXT x
    FOR x = 1 TO 4
        FOR y = 1 TO 3
            INPUT #1, precip(x, y)
        NEXT y
    NEXT x
    FOR x = 1 TO 4
        INPUT #1, hlevel(x)
    NEXT x
    FOR x = 1 TO 4
        INPUT #1, rxw$(x)
        xw$(x, 1) = LEFT$(rxw$(x), 1)
        xw$(x, 2) = MID$(rxw$(x), 2, 1)
        xw$(x, 3) = MID$(rxw$(x), 3, 1)
        xw$(x, 4) = RIGHT$(rxw$(x), 1)
    NEXT x
    CLOSE
    RETURN

20  ' Starting Date ******
   
    CLS
    PRINT "Current default year is "; campyear; " DR"
    PRINT "(Use `.5' if you want the year 0 DR)"
21  INPUT "The year please : "; year
    IF year = 0 THEN year = campyear
    IF year = .5 THEN year = 0
    IF INT(year) <> year AND year <> .5 THEN 21
    CLS
    PRINT "Gregorian"; TAB(24); "Celtic"; TAB(50); "Realms"
    PRINT STRING$(80, CHR$(205))
    PRINT "001 January"; TAB(24); "358 Beth"; TAB(50); "001 Hammer"
    PRINT "032 February"; TAB(24); "021 Luis"; TAB(50); "031 Midwinter"
    PRINT "060 March"; TAB(24); "049 Nion"; TAB(50); "032 Alturiak"
    PRINT "091 April"; TAB(24); "077 Fearn"; TAB(50); "062 Ches of the Sunsets"
    PRINT "121 May"; TAB(24); "105 Saille"; TAB(50); "092 Tarshak of the Storms"
    PRINT "152 June"; TAB(24); "133 Uath"; TAB(50); "122 Greengrass"
    PRINT "182 July"; TAB(24); "161 Duir"; TAB(50); "123 Mirtul"
    PRINT "213 August"; TAB(24); "189 Tinne"; TAB(50); "153 Kythorn"
    PRINT "244 September"; TAB(24); "217 Coll"; TAB(50); "183 Flamerule"
    PRINT "274 October"; TAB(24); "245 Muin"; TAB(50); "213 Midsummer"
    PRINT "305 November"; TAB(24); "273 Gort"; TAB(50); "214 Eleasias"
    PRINT "335 December"; TAB(24); "301 Pethbac"; TAB(50); "244 Eleint"
    PRINT TAB(24); "329 Ruis"; TAB(50); "245 Harvestide"
    PRINT TAB(24); "357 The Nameless Day"; TAB(50); "275 Marpenoth"
    PRINT TAB(50); "305 Uktar"
    PRINT TAB(50); "335 The Feast of the Moon"
    PRINT TAB(50); "336 Nightall"
    PRINT : PRINT "Last day processed = "; lastday
    PRINT "Default next day = "; lastday + 1
22  PRINT : PRINT "Day of the year "; year; " : "; : INPUT day
    IF (day > 365) OR (day < 0) THEN 22
    IF day <> INT(day) THEN 22
    IF day = 0 THEN day = lastday + 1
    month = INT((day - 1) * 12 / 365) + 1
    season = INT((month - 1) / 3) + 1
    RETURN

40  ' Temperature Values Assignments ******
   
    DATA -30,-50,-20,-40,-15,-30,-5,-20,0,-10,10,0,18,10,25,10,30,15,35,15
    DATA 40,20,50,30,60,40,65,45,70,50,70,55,75,55,80,60,80,65,85,65,85,70
    DATA 90,70,90,75,95,75,100,80,105,80,115,85,125,95
    FOR x = 0 TO 27
        READ dht(x), dlt(x)
    NEXT x
   
    DATA 30,20,15,10,5,5,0,0
    DATA 25,15,10,5,0,0,-5,-5
    DATA 20,10,0,-5,-5,-10,-15,-15
    DATA 15,0,-5,-10,-15,-20,-20,-25
    DATA 10,-5,-10,-15,-20,-25,-30,-30
    DATA 5,-10,-20,-25,-30,-35,-35,-40
    DATA 0,-15,-25,-30,-35,-40,-45,-45
    DATA -5,-20,-35,-40,-45,-50,-50,-55
    DATA -10,-25,-40,-45,-50,-55,-60,-65
    DATA -15,-30,-45,-50,-60,-60,-65,-70
    DATA -20,-40,-50,-60,-70,-75,-80,-80
    DATA -25,-45,-60,-70,-75,-80,-85,-90
    DATA -30,-50,-65,-75,-85,-90,-90,-95
    DATA -35,-60,-70,-80,-90,-95,-100,-100
    DATA -40,-65,-80,-90,-95,-100,-105,-110
    DATA -45,-70,-85,-95,-105,-110,-115,-115
    DATA -50,-75,-90,-100,-110,-115,-120,-120
    FOR x = 1 TO 17
        FOR y = 1 TO 8
            READ wcdata(x, y)
        NEXT y
    NEXT x
   
    RETURN
   
50  ' Initialize Values ******
   
    CLS
    COLOR 14: PRINT TAB(35); "Initialize Values"
    PRINT STRING$(80, CHR$(205)): COLOR 7
    VIEW PRINT 3 TO 24
    PRINT "<C/R> on inputs will assume random or null values"
51  INPUT "Wind speed (multiplles of 5) "; ywindspeed
    IF ywindspeed < 0 THEN 51
    IF (ywindspeed / 5) <> INT(ywindspeed / 5) THEN 51
    IF ywindspeed > maxwind THEN ywindspeed = maxwind
    PRINT : PRINT "Wind Direction"; TAB(30); "Number"
    PRINT STRING$(14, CHR$(205)); TAB(30); STRING$(6, CHR$(205))
    PRINT "From Artic"; TAB(33); "1": WD$(1) = "From Artic"
    PRINT "Prevailing"; TAB(33); "2": WD$(2) = "Prevailing"
    PRINT "From Tropics"; TAB(33); "3": WD$(3) = "From Tropics"
52  PRINT : INPUT "Wind direction number "; winddir
    IF winddir = 0 THEN winddir = INT(RND * 3) + 1
    IF winddir > 3 OR winddir < 1 THEN 52
    IF winddir <> INT(winddir) THEN 52
    PRINT : INPUT "Did it rain the previous day (y/n/R) "; a$
    IF a$ = "y" OR a$ = "Y" THEN 53
    IF a$ = "n" OR a$ = "N" THEN tprecip = 0: GOTO 54
    a = RND: IF a >= .75 THEN 55
    tprecip = 0: GOTO 54
55  r = precip(season, 2): tprecip = INT(sqrt(INT(RND * (r ^ 2) + 1)))
    IF tprecip < precip(season, 1) THEN tprecip = precip(season, 1)
    IF tprecip > precip(season, 2) THEN tprecip = precip(season, 2)
    GOTO 54
53  PRINT : PRINT "#", "Precipitation Level": FOR x = 1 TO 5: PRINT x, pre$(x): NEXT x
    PRINT : INPUT "To what extent did it rain "; tprecip
    IF tprecip <> INT(tprecip) THEN 53
    IF tprecip < 0 OR tprecip > 5 THEN 53
54  PRINT : PRINT "Temperature Levels"
    PRINT STRING$(40, CHR$(205))
    PRINT "Minimum("; temp(month, 1); ") Min:"; dlt(temp(month, 1)); " Max:"; dht(temp(month, 1))
    PRINT "Mean   ("; temp(month, 2); ") Min:"; dlt(temp(month, 2)); " Max:"; dht(temp(month, 2))
    PRINT "Maximum("; temp(month, 3); ") Min:"; dlt(temp(month, 3)); " Max:"; dht(temp(month, 3))
56  PRINT "Desired Previous Temperature Level ("; temp(month, 2); ") "; : INPUT ytemp
    IF ytemp <> INT(ytemp) THEN 56
    IF ytemp = 0 THEN ytemp = temp(month, 2)
    IF ytemp < temp(month, 1) OR ytemp > temp(month, 3) THEN 56
57  PRINT : PRINT "Available calendars : (1) GREGORIAN, (2) Celtic, (3) Realms"
    INPUT "Input # of output calendar "; cal
    IF cal <> INT(cal) THEN 57
    IF cal > 3 OR cal < 0 THEN 57
    IF cal = 0 THEN cal = 1
    PRINT : INPUT "Do you want to go immediately to printer (y/N) "; ans$
    IF ans$ = "y" OR ans$ = "Y" THEN 58
    VIEW PRINT
    RETURN
58  INPUT "How many days to go immediately to printer "; pdays
    VIEW PRINT
    RETURN

60  ' Main Program Loop (Daily Changes) ******
   
    month = INT((day - 1) * 12 / 365) + 1
    season = INT((month - 1) / 3) + 1
61  dice = INT(RND * 6) + INT(RND * 6) + 2
    GOTO 63
62  moo = INT(RND * 2) + 1
    IF moo = 1 THEN dice = 2
    IF moo = 2 THEN dice = 12
63  ndice = 0
    IF dice = 2 THEN ttemp = ytemp - 3: windspeed = ywindspeed + 20: GOTO 230: '           Special Weather ******
    IF dice = 3 THEN ttemp = ytemp - 2: tprecip = 0: ywindspeed = windspeed + 15: winddir = 1
    IF dice = 4 THEN ttemp = ytemp - 2: windspeed = ywindspeed + 10: winddir = 1: GOTO 70
    IF dice = 5 THEN ttemp = ytemp - 1: tprecip = 0: ywindspeed = windspeed + 15: winddir = 2
    IF dice = 6 THEN ttemp = ytemp - 1: windspeed = ywindspeed + 10: winddir = 2: GOTO 70
    IF dice = 7 THEN ttemp = ytemp: IF yprecip > 0 THEN 70: ' Precip. Possible ******
    IF dice = 8 THEN ttemp = ytemp + 1: windspeed = ywindspeed - 10: winddir = 2: GOTO 70
    IF dice = 9 THEN ttemp = ytemp + 1: tprecip = 0: ywindspeed = windspeed - 15: winddir = 2
    IF dice = 10 THEN ttemp = ytemp + 2: windspeed = ywindspeed - 10: winddir = 3: GOTO 70
    IF dice = 11 THEN ttemp = ytemp + 2: tprecip = 0: ywindspeed = windspeed - 15: winddir = 3
    IF dice = 12 THEN ttemp = ytemp + 3: windspeed = 0: GOTO 230: '          Special Weather ******
    GOTO 80

70  ' Precipitation Possibility Determination ******
   
    DPER = INT(RND * 100) + 1
    IF DPER <= 16 THEN tprecip = precip(season, 2)
    IF DPER > 16 AND DPER <= 58 THEN tprecip = precip(season, 1)
    IF DPER > 58 THEN tprecip = precip(season, 3)

80  ' Check Data ******
   
    IF ttemp > temp(month, 3) THEN ttemp = temp(month, 3)
    IF ttemp < temp(month, 1) THEN ttemp = temp(month, 1)
    IF windspeed > maxwind THEN windspeed = maxwind
    IF windspeed < 0 THEN windspeed = 0
   
85  ' Extreme Weather Workings ******
     
    duration = 0

    'Cold Wave
    IF xtra > 0 THEN
        ttemp = ytemp - 4
        IF ttemp < (temp(month, 1) - 1) THEN ttemp = temp(month, 1) - 1
    END IF

    'Cyclone/Hurricane/Typhoon
    IF xtrc > 0 THEN
        IF xtrc = 3 THEN
            ttemp = ytemp
            tprecip = 9
            windspeed = maxwind
            winddir = 3
        END IF
        IF xtrc = 2 THEN
            ttemp = ytemp
            tprecip = 6
            windspeed = (INT(RND * 6) + 1) * 20 + 60
            winddir = 3
        END IF
        IF xtrc = 1 THEN
            cdice = INT(RND * 6) + INT(RND * 6) + 2
            IF cdice < 7 THEN ttemp = ytemp - 1
            IF cdice = 7 THEN ttemp = ytemp
            IF cdice > 7 THEN ttemp = ytemp + 1
            winddir = 3
            windspeed = maxwind
        END IF
    END IF
   
    'Drought
    IF xtrd > 0 THEN
        lastrain = lastrain + 1
        tprecip = tprecip - 2
        IF tprecip < 0 THEN tprecip = 0
        IF tprecip > 0 AND lastrain < 6 THEN tprecip = 0
        IF tprecip > 0 THEN lastrain = 0
    END IF

    'Gale
    IF xtrg > 0 THEN
        windspeed = maxwind
        IF ywindspeed >= 20 THEN
            galespeed = INT(RND * 21) + 50
        ELSE
            galespeed = INT(RND * 6) * 5 + 40
        END IF
        IF ter$ = "Desert" THEN
            tprecip = 0
            xtrs = 1
        END IF
        IF cli$ = "Artic" OR cli$ = "Subartic" THEN
            xtrs = 1
        END IF
        duration = INT(RND * 6) + 2
    END IF

    'Mist or Fog
    IF xtrm > 0 THEN
        duration = INT(RND * 6) + 1
        IF duration < 4 THEN when$ = "Morning" ELSE when$ = "Evening"
    END IF

    'Sandstorm/Dust Storm/Blowing Snow
    IF xtrs > 0 THEN
        IF ter$ = "Desert" THEN tprecip = 0
        IF duration = 0 THEN duration = INT(RND * 4) + 1
    END IF

    'Tornado
    IF xtrt > 0 THEN
        IF ttemp < temp(month, 2) + 2 THEN ttemp = temp(month, 2) + 2
    END IF

    'Extreme Precipitation
    IF xtrx > 0 THEN
        a = INT(RND * 6) + 1
        avgtemp = (dht(ttemp) + dlt(ttemp)) / 2
        IF ter$ = "Tropical" OR ter$ = "Subtropical" THEN
            IF avgtemp >= 30 AND avgtemp < 36 THEN tprecip = 7
            IF avgtemp >= 36 AND avgtemp < 50 THEN
                IF a < 6 THEN tprecip = 9 ELSE tprecip = 7
            END IF
            IF avgtemp >= 50 AND avgtemp < 75 THEN tprecip = 9
            IF avgtemp >= 75 THEN tprecip = 9
        ELSE
            IF avgtemp < 0 AND a < 4 THEN tprecip = 10
            IF avgtemp >= 0 AND avgtemp < 10 THEN
                IF a < 6 THEN tprecip = 10
            END IF
            IF avgtemp >= 10 AND avgtemp < 30 THEN
                IF a < 6 THEN tprecip = 10 ELSE tprecip = 8
            END IF
            IF avgtemp >= 30 AND avgtemp < 36 THEN
                IF a < 5 THEN tprecip = 10
                IF a = 5 THEN tprecip = 7
                IF a = 6 THEN tprecip = 8
            END IF
            IF avgtemp >= 36 AND avgtemp < 50 THEN
                IF a < 5 THEN tprecip = 9 ELSE tprecip = 7
            END IF
            IF avgtemp >= 50 AND avgtemp < 75 THEN
                IF a < 6 THEN tprecip = 9 ELSE tprecip = 7
            END IF
            IF avgtemp > 75 THEN tprecip = 9
        END IF
    END IF

    'Heat Wave
    IF xtrz > 0 THEN
        ttemp = ytemp + 4
        IF ttemp > (temp(month, 3) + 1) THEN ttemp = temp(month, 3) + 1
    END IF

    'Generic Extreme Weather
    IF xtr > 0 THEN
        IF mode = 1 THEN
            windspeed = 45
            tprecip = precip(season, 2)
            a = RND
            IF a < .5 THEN winddir = 1 ELSE winddir = 2
         ELSE
            windspeed = 0
            tprecip = precip(season, 2)
            a = RND
            IF a < .5 THEN winddir = 2 ELSE winddir = 3
        END IF
    END IF

    ' Enduring Precipitation
    IF tprecip > 0 AND yprecip > 0 THEN
        xcounter = xtr + xtra + xtrc + xtrd + xtrg + xtrm + xtrs + xtrt + xtrx + xtrz
        a = RND
        IF xcounter = 0 AND a < .5 THEN tprecip = yprecip + 1
        IF tprecip > 5 THEN tprecip = 5
    END IF
   
    'Wind Chill Director
    IF dht(ttemp) <= 35 AND windspeed > 0 THEN wchtemp = dht(ttemp) ELSE wchtemp = 99
    IF dlt(ttemp) <= 35 AND windspeed > 0 THEN wcltemp = dlt(ttemp) ELSE wcltemp = 99
    IF wchtemp <= 35 OR wcltemp <= 35 AND windspeed > 0 THEN GOSUB 360
  
    ' Report Director ******
    IF pdays > 0 THEN 370

90  ' Screen Report ******
   
    CLS
    PRINT "Climate = "; cli$, "Terrain = "; ter$
    PRINT "Day "; day; " of the year "; year; "DR."
    CALL CalendarReport(cal, day, year, pdays)
    PRINT STRING$(40, CHR$(205))
    PRINT "Temperature - High : "; dht(ttemp); " F";
        IF wchtemp < 99 AND windspeed > 0 THEN
            COLOR 3, 0
            PRINT " Windchill "; wch; "F"
            COLOR 7, 0
        ELSE
            PRINT
        END IF
    PRINT "              Low  : "; dlt(ttemp); " F";
        IF wcltemp < 99 AND windspeed > 0 THEN
            COLOR 3, 0
            PRINT " Windchill "; wcl; "F"
            COLOR 7, 0
        ELSE
            PRINT
        END IF
    PRINT "Winds @ "; windspeed; " mph - "; WD$(winddir)
    PRINT STRING$(40, CHR$(205))
    IF tprecip > 0 AND tprecip < 6 THEN
        PRINT pre$(tprecip)
    END IF
    IF tprecip > 5 THEN
        GOSUB 350
    END IF
    IF xtra > 0 THEN COLOR 8, 1: PRINT "COLD WAVE": COLOR 7, 0
    IF xtrc > 0 THEN COLOR 3, 1: PRINT "CYCLONE/HURRICANE/TYPHOON": COLOR 7, 0
    IF xtrd > 0 THEN COLOR 14, 6: PRINT "DROUGHT": COLOR 7, 0
    IF xtrg > 0 THEN COLOR 9, 0: PRINT galespeed; " mph GALE": PRINT duration; " hours": COLOR 7, 0
    IF xtrm > 0 THEN COLOR 8, 0: PRINT "MIST OR FOG": PRINT when$; " "; duration; " hours": COLOR 7, 0
    IF xtrs > 0 THEN COLOR 0, 6: PRINT "SANDSTORM/DUSTSTORM/BLOWING SNOW": PRINT duration; " hours": COLOR 7, 0
    IF xtrt > 0 THEN COLOR 0, 1: PRINT "TORNADO": COLOR 7, 0
    IF xtrx > 0 THEN COLOR 1, 0: PRINT "EXTREME PRECIPITATION": COLOR 7, 0
    IF xtrz > 0 THEN COLOR 14, 4: PRINT "HEAT WAVE": COLOR 7, 0
    IF xtr > 0 THEN COLOR 15, 0: PRINT "EXTREME WEATHER": COLOR 7, 0
    PRINT
    CALL Moon(day, year, pdays, ter$)

93  IF pdays > 0 THEN 100
    LOCATE 20, 1
    PRINT "End of Day Options :"
    COLOR 14, 0: PRINT TAB(20); "(0)   Continue to Next Day": COLOR 7, 0
    PRINT TAB(5); "(1)   Change Climate/Terrain          (2)   Change Day"
    PRINT TAB(5); "(3)   Change Calendar                 (4)   Send weather to printer"
    PRINT TAB(5); "(5)   End Program                     "; : COLOR 4, 0: PRINT "(D/X) DM Override": COLOR 7, 0
92  a$ = INPUT$(1)
    IF a$ = "D" OR a$ = "d" THEN
        GOSUB 390
        GOTO 61
    END IF
    IF a$ = "X" OR a$ = "x" THEN
        GOSUB 390
        GOTO 62
    END IF
    ans = VAL(a$)
    IF ans = 1 THEN GOSUB 30: CLS : GOTO 93
    IF ans = 2 THEN GOSUB 190: CLS : GOTO 93
    IF ans = 3 THEN GOSUB 57: CLS : GOTO 93
    IF ans = 4 THEN GOSUB 380: CLS
    IF ans = 5 THEN CLS : GOTO 200
    IF ans > 5 OR ans < 0 THEN 92

100 ' End of Day Maintainence ******
   
    ytemp = ttemp
    yprecip = tprecip
    ywindspeed = windspeed
    day = day + 1
    IF day > 365 THEN day = 1: year = year + 1
    IF xtra > 0 THEN xtra = xtra - 1
    IF xtrc > 0 THEN xtrc = xtrc - 1
    IF xtrd > 0 THEN xtrd = xtrd - 1
    IF xtrg > 0 THEN xtrg = xtrg - 1
    IF xtrm > 0 THEN xtrm = xtrm - 1
    IF xtrs > 0 THEN xtrs = xtrs - 1
    IF xtrt > 0 THEN xtrt = xtrt - 1
    IF xtrx > 0 THEN xtrx = xtrx - 1
    IF xtrz > 0 THEN xtrz = xtrz - 1
    IF xtr > 0 THEN xtr = xtr - 1
    IF mode <> 0 THEN mode = 0
    wchtemp = 99: wcltemp = 99
    GOTO 60



190 ' Change Day Subroutine ******
   
    PRINT : PRINT "Current year is "; year; " DR"
191 INPUT "New year (0=do not change year,.5= year 0 DR) "; moo
    IF moo = 0 THEN
        year = year
    ELSEIF moo = .5 THEN
        year = 0
    ELSEIF moo <> INT(moo) AND moo <> .5 THEN
        GOTO 191
    ELSE
        year = moo
    END IF
    PRINT : PRINT "Current day is "; day
    INPUT "New day # for tomorrow "; moo
    day = moo - 1
    IF day = 0 THEN day = 365
    RETURN

200 ' End of Program ******
   
    OPEN "weather.cnf" FOR OUTPUT AS #1
    WRITE #1, year, datdir$, day
    CLOSE
   
201 END

220 'Configuration Read & Update ******
    OPEN "weather.cnf" FOR INPUT AS #1
    INPUT #1, campyear, datdir$, lastday
    CLOSE
    CLS
    PRINT "The following defaults are listed :"
    PRINT "              Campaign Year = "; campyear
    PRINT "             Data directory = "; datdir$
    PRINT "         Last day Processed = "; lastday
    PRINT
    INPUT "Do you wish to change any or these items (y/N) "; ans$
    IF ans$ = "y" OR ans$ = "Y" THEN 221
    RETURN
221 PRINT : INPUT "New campaign year "; campyear
    PRINT : INPUT "New data directory (eg `C:\dnd\weather\') "; datdir$
    IF LEN(datdir$) < 2 THEN datdir$ = ".\"
    IF RIGHT$(datdir$, 1) <> "\" THEN datdir$ = datdir$ + "\"
    OPEN "weather.cnf" FOR OUTPUT AS #1
    WRITE #1, campyear, datdir$, lastday
    CLOSE
    RETURN

230 'Extreme Weather Director ******

    ndice = INT(RND * 6) + INT(RND * 6) + 2
    IF dice = 2 AND ndice > 7 THEN tx$ = "-"
    IF dice = 12 AND ndice < 7 THEN tx$ = "-"
    IF dice = 2 THEN
        IF ndice <= 4 THEN tx$ = xw$(season, 1)
        IF ndice > 4 AND ndice <= 7 THEN tx$ = xw$(season, 2)
    END IF
    IF dice = 12 THEN
        IF ndice > 6 AND ndice <= 9 THEN tx$ = xw$(season, 3)
        IF ndice > 9 THEN tx$ = xw$(season, 4)
    END IF
   
    IF tx$ = "A" THEN 240   'Cold Wave
    IF tx$ = "C" THEN 250   'Cyclone/Hurricane/Typhoon
    IF tx$ = "D" THEN 260   'Drought
    IF tx$ = "G" THEN 270   'Gale
    IF tx$ = "M" THEN 280   'Mist or Fog
    IF tx$ = "S" THEN 290   'Sandstorm
    IF tx$ = "T" THEN 300   'Tornado
    IF tx$ = "X" THEN 310   'Extreme Precipitation
    IF tx$ = "Z" THEN 320   'Heat Wave
    IF tx$ = "-" AND dice = 2 THEN 330
    IF tx$ = "-" AND dice = 12 THEN 340

240 ' Cold Wave
    xtra = INT(RND * 6) + 3
    GOTO 80

250 ' Cyclone/Hurricane/Typhoon
    xtrc = 3
    GOTO 80

260 ' Drought
    xtrd = INT(RND * 6) + INT(RND * 6) + 4
    GOTO 80

270 ' Gale
    xtrg = 1
    GOTO 80

280 ' Mist or Fog
    xtrm = 1
    GOTO 80

290 ' Sandstorm/Dust Storm/Blowing Snow
    xtrs = 1
    GOTO 80

300 ' Tornado
    xtrt = 1
    GOTO 80

310 ' Extreme Precipitation
    xtrx = 1
    GOTO 80

320 ' Heat Wave
    xtrz = INT(RND * 6) + 3
    GOTO 80

330 '-2 resuts
    xtr = 1
    mode = 1
    GOTO 80

340 '-12 results
    xtr = 1
    mode = 2
    GOTO 80

350 'Extreme Precipitation Reports
    IF pdays > 0 THEN 351
    IF tprecip = 6 THEN COLOR 8, 1: PRINT "Torrential Rains (3in+)"
    IF tprecip = 7 THEN COLOR 31, 0: PRINT "Hailstorm"
    IF tprecip = 8 THEN COLOR 9, 0: PRINT "Ice/Sleet Storm"
    IF tprecip = 9 THEN COLOR 30, 0: PRINT "Lightening Storm"
    IF tprecip = 10 THEN
        a = INT(RND * 6) + 1
        IF precip(season, 2) < 4 THEN a = a + 4
        IF precip(season, 2) >= 4 THEN a = a + 6
        COLOR 15, 1: PRINT "Severe Snowstorm ("; a; " in)"
    END IF
    COLOR 7, 0
    RETURN

351 IF tprecip = 6 THEN LPRINT "Torrential Rains (3in+)"
    IF tprecip = 7 THEN LPRINT "Hailstorm"
    IF tprecip = 8 THEN LPRINT "Ice/Sleet Storm"
    IF tprecip = 9 THEN LPRINT "Lightening Storm"
    IF tprecip = 10 THEN
        a = INT(RND * 6) + 1
        IF precip(season, 2) < 4 THEN a = a + 4
        IF precip(season, 2) >= 4 THEN a = a + 6
        LPRINT "Severe Snowstorm ("; a; " in)"
    END IF
    RETURN


360 'Wind Chill Effects
    b = windspeed / 5
    IF b > 8 THEN b = 8
    IF wchtemp <= 35 THEN
        a = 18 - (INT(wchtemp / 5) + 10)
        IF a > 17 THEN a = 17
        wch = wcdata(a, b)
    END IF
    IF wcltemp <= 35 THEN
        c = 18 - (INT(wcltemp / 5) + 10)
        IF c > 17 THEN c = 17
        wcl = wcdata(c, b)
    END IF
    RETURN
  
370 ' Printed Report ******
    LPRINT "Climate = "; cli$, "Terrain = "; ter$
    LPRINT "Day "; day; " of the year "; year; "DR."
    CALL CalendarReport(cal, day, year, pdays)
    LPRINT "===================================="
    LPRINT "Temperature - High : "; dht(ttemp); " F";
        IF wchtemp < 99 AND windspeed > 0 THEN
            LPRINT " Windchill "; wch; "F"
        ELSE
            LPRINT
        END IF
    LPRINT "              Low  : "; dlt(ttemp); " F";
        IF wcltemp < 99 AND windspeed > 0 THEN
            LPRINT " Windchill "; wcl; "F"
        ELSE
            LPRINT
        END IF
    LPRINT "Winds @ "; windspeed; " mph - "; WD$(winddir)
    LPRINT "===================================="
    IF tprecip > 0 AND tprecip < 6 THEN
        LPRINT pre$(tprecip)
    END IF
    IF tprecip > 5 THEN
        GOSUB 350
    END IF
    IF xtra > 0 THEN LPRINT "COLD WAVE"
    IF xtrc > 0 THEN LPRINT "CYCLONE/HURRICANE/TYPHOON"
    IF xtrd > 0 THEN LPRINT "DROUGHT"
    IF xtrg > 0 THEN LPRINT galespeed; " mph GALE": PRINT duration; " hours"
    IF xtrm > 0 THEN LPRINT "MIST OR FOG": PRINT when$; " "; duration; " hours"
    IF xtrs > 0 THEN LPRINT "SANDSTORM/DUSTSTORM/BLOWING SNOW": PRINT duration; " hours"
    IF xtrt > 0 THEN LPRINT "TORNADO"
    IF xtrx > 0 THEN LPRINT "EXTREME PRECIPITATION"
    IF xtrz > 0 THEN LPRINT "HEAT WAVE"
    IF xtr > 0 THEN LPRINT "EXTREME WEATHER"
    LPRINT
    CALL Moon(day, year, pdays, ter$)
    FOR x = 1 TO 5: LPRINT : NEXT x
    pdays = pdays - 1
    GOTO 93

380 ' Sending Weather to Printer

    CLS
    PRINT "Current area is "; cli$, ter$
    PRINT
381 INPUT "Number of days of weather to send to printer "; pdays
    IF pdays <> INT(pdays) OR pdays < 0 THEN 381
    RETURN

390 'Clear New Extreme Weather
  
    IF ndice = 0 THEN 39001
  
    IF dice = 2 AND ndice > 7 THEN tx$ = "-"
    IF dice = 12 AND ndice < 7 THEN tx$ = "-"
    IF dice = 2 THEN
        IF ndice <= 4 THEN tx$ = xw$(season, 1)
        IF ndice > 4 AND ndice <= 7 THEN tx$ = xw$(season, 2)
    END IF
    IF dice = 12 THEN
        IF ndice > 6 AND ndice <= 9 THEN tx$ = xw$(season, 3)
        IF ndice > 9 THEN tx$ = xw$(season, 4)
    END IF
 
    IF tx$ = "A" THEN 39240   'Cold Wave
    IF tx$ = "C" THEN 39250   'Cyclone/Hurricane/Typhoon
    IF tx$ = "D" THEN 39260   'Drought
    IF tx$ = "G" THEN 39270   'Gale
    IF tx$ = "M" THEN 39280   'Mist or Fog
    IF tx$ = "S" THEN 39290   'Sandstorm
    IF tx$ = "T" THEN 39300   'Tornado
    IF tx$ = "X" THEN 39310   'Extreme Precipitation
    IF tx$ = "Z" THEN 39320   'Heat Wave
    IF tx$ = "-" AND dice = 2 THEN 39330
    IF tx$ = "-" AND dice = 12 THEN 39340

39240 ' Cold Wave
    xtra = 0
    GOTO 39001

39250 ' Cyclone/Hurricane/Typhoon
    xtrc = 0
    GOTO 39001

39260 ' Drought
    xtrd = 0
    GOTO 39001

39270 ' Gale
    xtrg = 0
        IF ter$ = "Desert" THEN
            xtrs = 0
        END IF
        IF cli$ = "Artic" OR cli$ = "Subartic" THEN
            xtrs = 0
        END IF
    GOTO 39001

39280 ' Mist or Fog
    xtrm = 0
    GOTO 39001

39290 ' Sandstorm/Dust Storm/Blowing Snow
    xtrs = 0
    GOTO 39001

39300 ' Tornado
    xtrt = 0
    GOTO 39001

39310 ' Extreme Precipitation
    xtrx = 0
    GOTO 39001

39320 ' Heat Wave
    xtrz = 0
    GOTO 39001
         
39330 '-2 resuts
    xtr = 0
    mode = 1
    GOTO 39001

39340 '-12 results
    xtr = 0
    mode = 2
    GOTO 39001

39001 'Bounce target  
    RETURN

ErrorHandler:
    BADFILENAME = 53
    IF ERR = BADFILENAME THEN
        ' get another file name
        PRINT "File "; UCASE$(fm$); " not found."
        PRINT : PRINT TAB(20); "Available files"
        FILES datdir$ + "*.dat"
        PRINT
1       INPUT "Input new data file name (filename.dat) "; fm$
        IF LEN(fm$) < 1 THEN 1
        fm$ = datdir$ + fm$
        RESUME
    ELSE
        ' some other error, so print message and abort
        PRINT "Unrecoverable error--"; ERR
        ON ERROR GOTO 0
    END IF

SUB CalendarReport (cal, day, year, pdays)
    SELECT CASE cal
    CASE 1:                'Gregorian Calendar Dates
        IF pdays = 0 THEN
            IF day < 32 THEN
                PRINT "January " + STR$(day) + ", " + STR$(year) + " DR"
            ELSEIF day > 31 AND day < 60 THEN
                PRINT "February" + STR$(day - 31) + ", " + STR$(year) + " DR"
            ELSEIF day > 59 AND day < 91 THEN
                PRINT "March" + STR$(day - 59) + ", " + STR$(year) + " DR"
            ELSEIF day > 90 AND day < 121 THEN
                PRINT "April" + STR$(day - 90) + ", " + STR$(year) + " DR"
            ELSEIF day > 120 AND day < 152 THEN
                PRINT "May" + STR$(day - 120) + ", " + STR$(year) + " DR"
            ELSEIF day > 151 AND day < 182 THEN
                PRINT "June" + STR$(day - 151) + ", " + STR$(year) + " DR"
            ELSEIF day > 181 AND day < 213 THEN
                PRINT "July" + STR$(day - 181) + ", " + STR$(year) + " DR"
            ELSEIF day > 212 AND day < 244 THEN
                PRINT "August" + STR$(day - 212) + ", " + STR$(year) + " DR"
            ELSEIF day > 243 AND day < 274 THEN
                PRINT "September" + STR$(day - 243) + ", " + STR$(year) + " DR"
            ELSEIF day > 273 AND day < 305 THEN
                PRINT "October" + STR$(day - 273) + ", " + STR$(year) + " DR"
            ELSEIF day > 304 AND day < 335 THEN
                PRINT "November" + STR$(day - 304) + ", " + STR$(year) + " DR"
            ELSE
                PRINT "December" + STR$(day - 334) + ", " + STR$(year) + " DR"
            END IF
         
            IF day > 355 OR day < 80 THEN
                COLOR 7, 1: PRINT "Winter"
            ELSEIF day > 79 AND day < 173 THEN
                COLOR 14, 2: PRINT "Spring"
            ELSEIF day > 172 AND day < 264 THEN
                COLOR 2, 0: PRINT "Summer"
            ELSE
                COLOR 8, 6: PRINT "Autumn"
            END IF
            COLOR 7, 0
          
        END IF
     
        IF pdays > 0 THEN
            IF day < 32 THEN
                LPRINT "January " + STR$(day) + ", " + STR$(year) + " DR"
            ELSEIF day > 31 AND day < 60 THEN
                LPRINT "February" + STR$(day - 31) + ", " + STR$(year) + " DR"
            ELSEIF day > 59 AND day < 91 THEN
                LPRINT "March" + STR$(day - 59) + ", " + STR$(year) + " DR"
            ELSEIF day > 90 AND day < 121 THEN
                LPRINT "April" + STR$(day - 90) + ", " + STR$(year) + " DR"
            ELSEIF day > 120 AND day < 152 THEN
                LPRINT "May" + STR$(day - 120) + ", " + STR$(year) + " DR"
            ELSEIF day > 151 AND day < 182 THEN
                LPRINT "June" + STR$(day - 151) + ", " + STR$(year) + " DR"
            ELSEIF day > 181 AND day < 213 THEN
                LPRINT "July" + STR$(day - 181) + ", " + STR$(year) + " DR"
            ELSEIF day > 212 AND day < 244 THEN
                LPRINT "August" + STR$(day - 212) + ", " + STR$(year) + " DR"
            ELSEIF day > 243 AND day < 274 THEN
                LPRINT "September" + STR$(day - 243) + ", " + STR$(year) + " DR"
            ELSEIF day > 273 AND day < 305 THEN
                LPRINT "October" + STR$(day - 273) + ", " + STR$(year) + " DR"
            ELSEIF day > 304 AND day < 335 THEN
                LPRINT "November" + STR$(day - 304) + ", " + STR$(year) + " DR"
            ELSE
                LPRINT "December" + STR$(day - 334) + ", " + STR$(year) + " DR"
            END IF
          
            IF day > 355 OR day < 80 THEN
                LPRINT "Winter"
            ELSEIF day > 79 AND day < 173 THEN
                LPRINT "Spring"
            ELSEIF day > 172 AND day < 264 THEN
                LPRINT "Summer"
            ELSE
                LPRINT "Autumn"
            END IF

        END IF
 
    CASE 2:                     'Celtic Calendar
        IF pdays = 0 THEN
            IF day >= 358 THEN
                PRINT "Beth" + STR$(day - 357) + ", " + STR$(year) + " DR"
            ELSEIF day < 21 THEN
                PRINT "Beth" + STR$(day + 8) + ", " + STR$(year) + " DR"
            ELSEIF day >= 21 AND day < 49 THEN
                PRINT "Luis" + STR$(day - 20) + ", " + STR$(year) + " DR"
            ELSEIF day >= 49 AND day < 77 THEN
                PRINT "Nion" + STR$(day - 48) + ", " + STR$(year) + " DR"
            ELSEIF day >= 77 AND day < 105 THEN
                PRINT "Fearn" + STR$(day - 76) + ", " + STR$(year) + " DR"
            ELSEIF day >= 105 AND day < 133 THEN
                PRINT "Saille" + STR$(day - 104) + ", " + STR$(year) + " DR"
            ELSEIF day >= 133 AND day < 161 THEN
                PRINT "Uath" + STR$(day - 132) + ", " + STR$(year) + " DR"
            ELSEIF day >= 161 AND day < 189 THEN
                PRINT "Duir" + STR$(day - 160) + ", " + STR$(year) + " DR"
            ELSEIF day >= 189 AND day < 217 THEN
                PRINT "Tinne" + STR$(day - 188) + ", " + STR$(year) + " DR"
            ELSEIF day >= 217 AND day < 245 THEN
                PRINT "Coll" + STR$(day - 216) + ", " + STR$(year) + " DR"
            ELSEIF day >= 245 AND day < 273 THEN
                PRINT "Muin" + STR$(day - 244) + ", " + STR$(year) + " DR"
            ELSEIF day >= 273 AND day < 301 THEN
                PRINT "Gort" + STR$(day - 272) + ", " + STR$(year) + " DR"
            ELSEIF day >= 301 AND day < 329 THEN
                PRINT "Pethbac or Ngetal" + STR$(day - 300) + ", " + STR$(year) + " DR"
            ELSE
                PRINT "Ruis" + STR$(day - 328) + ", " + STR$(year) + " DR"
            END IF

            IF day > 357 OR day < 65 THEN
                COLOR 7, 1: PRINT "Sleep/Burgeoning"
            ELSEIF day > 64 AND day < 137 THEN
                COLOR 14, 2: PRINT "Spring/Flowering"
            ELSEIF day > 136 AND day < 209 THEN
                COLOR 14, 4: PRINT "Setting/Ripening"
            ELSEIF day > 208 AND day < 281 THEN
                COLOR 14, 6: PRINT "Harvest/Gathering"
            ELSEIF day > 280 AND day < 353 THEN
                COLOR 0, 6: PRINT "Fall/Fading"
            ELSE
                COLOR 8, 1: PRINT "Winter/Sorrowing"
            END IF
            COLOR 7, 0
     
        END IF

        IF pdays > 0 THEN
            IF day >= 358 THEN
                LPRINT "Beth" + STR$(day - 357) + ", " + STR$(year) + " DR"
            ELSEIF day < 21 THEN
                LPRINT "Beth" + STR$(day + 8) + ", " + STR$(year) + " DR"
            ELSEIF day >= 21 AND day < 49 THEN
                LPRINT "Luis" + STR$(day - 20) + ", " + STR$(year) + " DR"
            ELSEIF day >= 49 AND day < 77 THEN
                LPRINT "Nion" + STR$(day - 48) + ", " + STR$(year) + " DR"
            ELSEIF day >= 77 AND day < 105 THEN
                LPRINT "Fearn" + STR$(day - 76) + ", " + STR$(year) + " DR"
            ELSEIF day >= 105 AND day < 133 THEN
                LPRINT "Saille" + STR$(day - 104) + ", " + STR$(year) + " DR"
            ELSEIF day >= 133 AND day < 161 THEN
                LPRINT "Uath" + STR$(day - 132) + ", " + STR$(year) + " DR"
            ELSEIF day >= 161 AND day < 189 THEN
                LPRINT "Duir" + STR$(day - 160) + ", " + STR$(year) + " DR"
            ELSEIF day >= 189 AND day < 217 THEN
                LPRINT "Tinne" + STR$(day - 188) + ", " + STR$(year) + " DR"
            ELSEIF day >= 217 AND day < 245 THEN
                LPRINT "Coll" + STR$(day - 216) + ", " + STR$(year) + " DR"
            ELSEIF day >= 245 AND day < 273 THEN
                LPRINT "Muin" + STR$(day - 244) + ", " + STR$(year) + " DR"
            ELSEIF day >= 273 AND day < 301 THEN
                LPRINT "Gort" + STR$(day - 272) + ", " + STR$(year) + " DR"
            ELSEIF day >= 301 AND day < 329 THEN
                LPRINT "Pethbac or Ngetal" + STR$(day - 300) + ", " + STR$(year) + " DR"
            ELSE
                LPRINT "Ruis" + STR$(day - 328) + ", " + STR$(year) + " DR"
            END IF
 
            IF day > 357 OR day < 65 THEN
                LPRINT "Sleep/Burgeoning"
            ELSEIF day > 64 AND day < 137 THEN
                LPRINT "Spring/Flowering"
            ELSEIF day > 136 AND day < 209 THEN
                LPRINT "Setting/Ripening"
            ELSEIF day > 208 AND day < 281 THEN
                LPRINT "Harvest/Gathering"
            ELSEIF day > 280 AND day < 353 THEN
                LPRINT "Fall/Fading"
            ELSE
                LPRINT "Winter/Sorrowing"
            END IF
     
        END IF

    CASE 3:                 ' Realms Calendar Dates ******
        IF pdays = 0 THEN
            IF day >= 1 AND day < 31 THEN
                PRINT "Hammer" + STR$(day) + ", " + STR$(year) + " DR"
            ELSEIF day = 31 THEN
                COLOR 7, 1: PRINT "Midwinter" + ", " + STR$(year) + " DR"
            ELSEIF day >= 32 AND day < 62 THEN
                PRINT "Alturiak" + STR$(day - 31) + ", " + STR$(year) + " DR"
            ELSEIF day >= 62 AND day < 92 THEN
                PRINT "Ches of the Sunsets" + STR$(day - 61) + ", " + STR$(year) + " DR"
            ELSEIF day >= 92 AND day < 122 THEN
                PRINT "Tarshak of the Storms" + STR$(day - 91) + ", " + STR$(year) + " DR"
            ELSEIF day = 122 THEN
                COLOR 14, 2: PRINT "Greengrass" + ", " + STR$(year) + " DR"
            ELSEIF day >= 123 AND day < 153 THEN
                PRINT "Mirtul" + STR$(day - 122) + ", " + STR$(year) + " DR"
            ELSEIF day >= 153 AND day < 183 THEN
                PRINT "Kythorn" + STR$(day - 152) + ", " + STR$(year) + " DR"
            ELSEIF day >= 183 AND day < 213 THEN
                PRINT "Flamerule" + STR$(day - 182) + ", " + STR$(year) + " DR"
            ELSEIF day = 213 THEN
                COLOR 6, 2: PRINT "Midsummer" + ", " + STR$(year) + " DR"
            ELSEIF day >= 214 AND day < 244 THEN
                PRINT "Eleasias" + STR$(day - 213) + ", " + STR$(year) + " DR"
            ELSEIF day = 244 THEN
                COLOR 7, 6: PRINT "Eleint" + ", " + STR$(year) + " DR"
            ELSEIF day >= 245 AND day < 275 THEN
                PRINT "Harvestide" + STR$(day - 244) + ", " + STR$(year) + " DR"
            ELSEIF day >= 275 AND day < 305 THEN
                PRINT "Marpenoth" + STR$(day - 274) + ", " + STR$(year) + " DR"
            ELSEIF day >= 305 AND day < 335 THEN
                PRINT "Uktar" + STR$(day - 304) + ", " + STR$(year) + " DR"
            ELSEIF day = 335 THEN
                COLOR 0, 1: PRINT "The Feast of the Moon" + ", " + STR$(year) + " DR"
            ELSE
                PRINT "Nightall" + STR$(day - 335) + ", " + STR$(year) + " DR"
            END IF
            COLOR 7, 0

            IF day > 355 OR day < 80 THEN
                COLOR 7, 1: PRINT "Winter"
            ELSEIF day > 79 AND day < 173 THEN
                COLOR 14, 2: PRINT "Spring"
            ELSEIF day > 172 AND day < 264 THEN
                COLOR 2, 0: PRINT "Summer"
            ELSE
                COLOR 0, 6: PRINT "Autumn"
            END IF
            COLOR 7, 0

        END IF

        IF pdays > 0 THEN
            IF day >= 1 AND day < 31 THEN
                LPRINT "Hammer" + STR$(day) + ", " + STR$(year) + " DR"
            ELSEIF day = 31 THEN
                LPRINT "Midwinter" + ", " + STR$(year) + " DR"
            ELSEIF day >= 32 AND day < 62 THEN
                LPRINT "Alturiak" + STR$(day - 31) + ", " + STR$(year) + " DR"
            ELSEIF day >= 62 AND day < 92 THEN
                LPRINT "Ches of the Sunsets" + STR$(day - 61) + ", " + STR$(year) + " DR"
            ELSEIF day >= 92 AND day < 122 THEN
                LPRINT "Tarshak of the Storms" + STR$(day - 91) + ", " + STR$(year) + " DR"
            ELSEIF day = 122 THEN
                LPRINT "Greengrass" + ", " + STR$(year) + " DR"
            ELSEIF day >= 123 AND day < 153 THEN
                LPRINT "Mirtul" + STR$(day - 122) + ", " + STR$(year) + " DR"
            ELSEIF day >= 153 AND day < 183 THEN
                LPRINT "Kythorn" + STR$(day - 152) + ", " + STR$(year) + " DR"
            ELSEIF day >= 183 AND day < 213 THEN
                LPRINT "Flamerule" + STR$(day - 182) + ", " + STR$(year) + " DR"
            ELSEIF day = 213 THEN
                LPRINT "Midsummer" + ", " + STR$(year) + " DR"
            ELSEIF day >= 214 AND day < 244 THEN
                LPRINT "Eleasias" + STR$(day - 213) + ", " + STR$(year) + " DR"
            ELSEIF day = 244 THEN
                LPRINT "Eleint" + ", " + STR$(year) + " DR"
            ELSEIF day >= 245 AND day < 275 THEN
                LPRINT "Harvestide" + STR$(day - 244) + ", " + STR$(year) + " DR"
            ELSEIF day >= 275 AND day < 305 THEN
                LPRINT "Marpenoth" + STR$(day - 274) + ", " + STR$(year) + " DR"
            ELSEIF day >= 305 AND day < 335 THEN
                LPRINT "Uktar" + STR$(day - 304) + ", " + STR$(year) + " DR"
            ELSEIF day = 335 THEN
                LPRINT "The Feast of the Moon" + ", " + STR$(year) + " DR"
            ELSE
                LPRINT "Nightall" + STR$(day - 335) + ", " + STR$(year) + " DR"
            END IF

            IF day > 355 OR day < 80 THEN
                LPRINT "Winter"
            ELSEIF day > 79 AND day < 173 THEN
                LPRINT "Spring"
            ELSEIF day > 172 AND day < 264 THEN
                LPRINT "Summer"
            ELSE
                LPRINT "Autumn"
            END IF

        END IF
    END SELECT
 
    SELECT CASE pdays: ' Special Day Names ******
        CASE IS = 0
            COLOR 14, 0, 0
            IF day = 1 THEN PRINT "Gregorian/Realms New Year's Day"
            IF day = 32 THEN PRINT "Imbolc or Oilmelg"
            IF day = 80 THEN PRINT "Vernal Equinox"
            IF day = 121 THEN PRINT "Beltaine"
            IF day = 172 THEN PRINT "Midsummer's Eve"
            IF day = 173 THEN PRINT "Midsummer's Day/Summer Solstice"
            IF day = 213 THEN PRINT "Lughnasa or Luguasad"
            IF day = 264 THEN PRINT "Autumnal Equinox"
            IF day = 304 THEN PRINT "Halloween"
            IF day = 305 THEN PRINT "Samhain"
            IF day >= 355 AND day <= 357 THEN PRINT "Winter Solstice Festivities"
            IF day = 357 THEN PRINT "The Nameless Day"
            IF day = 358 THEN PRINT "Celtic New Year's Day"
            IF day = 365 THEN PRINT "Gregorian/Realms New Year's Eve"
            COLOR 7, 0, 0
     
        CASE IS > 0
            IF day = 1 THEN LPRINT "Gregorian/Realms New Year's Day"
            IF day = 32 THEN LPRINT "Imbolc or Oilmelg"
            IF day = 80 THEN LPRINT "Vernal Equinox"
            IF day = 121 THEN LPRINT "Beltaine"
            IF day = 172 THEN LPRINT "Midsummer's Eve"
            IF day = 173 THEN LPRINT "Midsummer's Day/Summer Solstice"
            IF day = 213 THEN LPRINT "Lughnasa or Luguasad"
            IF day = 264 THEN LPRINT "Autumnal Equinox"
            IF day = 304 THEN LPRINT "Halloween"
            IF day = 305 THEN LPRINT "Samhain"
            IF day >= 355 AND day <= 357 THEN LPRINT "Winter Solstice Festivities"
            IF day = 357 THEN LPRINT "The Nameless Day"
            IF day = 358 THEN LPRINT "Celtic New Year's Day"
            IF day = 365 THEN LPRINT "Gregorian/Realms New Year's Eve"
     
    END SELECT
  
END SUB

SUB Introduction
   
    COLOR 15, 1, 0
    CLS
    PRINT : PRINT
    PRINT "                                       "
    PRINT "                                                "
    PRINT "                                          "
    PRINT "                                                "
    PRINT "                                          "
    PRINT
    PRINT "                               "
    PRINT "                                             "
    PRINT "                                    "
    PRINT "                                            "
    PRINT "                                      "
    PRINT : PRINT
    COLOR 7, 1
    PRINT TAB(50); "by Michael J. McLaughlin"
    PRINT TAB(50); "Version 3.00"
    PRINT TAB(50); "March 1992"
    a$ = INPUT$(1)
    COLOR 7, 0, 0

END SUB

SUB Moon (day, year, pdays, ter$)
   
    LNMONTH = 28
    zerotime = 1000!

    ' Determine the Moon's Phase & Tides ******
    moonper = ((year - zerotime) * 365 + day) MOD 28
    hightime = (moonper / 28) * 24 + 12
    IF hightime > 24 THEN hightime = hightime - 24
    IF hightime >= 12 THEN lowtime = hightime - 12
    IF hightime < 12 THEN lowtime = hightime + 12
   
    SELECT CASE pdays
        CASE IS = 0
            PRINT "Phase of the Luna : ";
            IF moonper <= 1 OR moonper > 25 THEN
                COLOR 8, 0: PRINT "New Moon"
            ELSEIF moonper <= 4 AND moonper > 1 THEN
                COLOR 7, 0: PRINT "Waxing Cresent"
            ELSEIF moonper <= 8 AND moonper > 4 THEN
                COLOR 7, 1: PRINT "First Quarter"
            ELSEIF moonper <= 11 AND moonper > 8 THEN
                COLOR 7, 1: PRINT "Waxing Gibbus"
            ELSEIF moonper <= 15 AND moonper > 11 THEN
                COLOR 15, 1: PRINT "Full Moon"
            ELSEIF moonper <= 18 AND moonper > 15 THEN
                COLOR 7, 1: PRINT "Waning Gibbus"
            ELSEIF moonper <= 22 AND moonper > 18 THEN
                COLOR 7, 1: PRINT "Last Quarter"
            ELSE
                COLOR 7, 0: PRINT "Waning Cresent"
            END IF
            COLOR 7, 0
   
            IF ter$ = "Seacoast" THEN
                PRINT
                PRINT "High Tide @ "; INT(hightime); ":"; INT((hightime - INT(hightime)) * 60)
                PRINT "Low Tide @ "; INT(lowtime); ":"; INT((lowtime - INT(lowtime)) * 60)
            END IF
   
        CASE IS > 0
            IF moonper <= 1 OR moonper > 25 THEN
                LPRINT "New Moon"
            ELSEIF moonper <= 4 AND moonper > 1 THEN
                LPRINT "Waxing Cresent"
            ELSEIF moonper <= 8 AND moonper > 4 THEN
                LPRINT "First Quarter"
            ELSEIF moonper <= 11 AND moonper > 8 THEN
                LPRINT "Waxing Gibbus"
            ELSEIF moonper <= 15 AND moonper > 11 THEN
                LPRINT "Full Moon"
            ELSEIF moonper <= 18 AND moonper > 15 THEN
                LPRINT "Waning Gibbus"
            ELSEIF moonper <= 22 AND moonper > 18 THEN
                LPRINT "Last Quarter"
            ELSE
                LPRINT "Waning Cresent"
            END IF
           
            IF ter$ = "Seacoast" THEN
                LPRINT
                LPRINT "High Tide @ "; INT(hightime); ":"; INT((hightime - INT(hightime)) * 60)
                LPRINT "Low Tide @ "; INT(lowtime); ":"; INT((lowtime - INT(lowtime)) * 60)
            END IF
       
    END SELECT
END SUB

